(****************************************************************************)
(*  Copyright (C) 2011 Ralf Treinen <ralf.treinen@pps.jussieu.fr>           *)
(*  Copyright (C) 2011 Mancoosi Project                                     *)
(*                                                                          *)
(*  This module is free software: you can redistribute it and/or modify     *)
(*  it under the terms of the GNU Lesser General Public License as          *)
(*  published by the Free Software Foundation, either version 3 of the      *)
(*  License, or (at your option) any later version.  A special linking      *)
(*  exception to the GNU Lesser General Public License applies to this      *)
(*  library, see the COPYING file for more information.                     *)
(****************************************************************************)


(* tests of module url *)

let check s =
  let result = Url.to_string (Url.from_string s)
  and normalized_input =
    let lastchar =String.get s ((String.length s) -1)
    in
    if lastchar = ';' || lastchar ='?'
    then String.sub s 0 ((String.length s) -1)
    else s
  in if normalized_input <> result
    then print_string ("Error parsing: "^s^"\n");
;;

check "deb://kjkdf?dd";;
check "deb:///ab/cd";;
check "sqlite://user@becane:80/a/b/c";;
check "sqlite://user:secret@machine/a/b/c";;
check "sqlite://user@machine/a:c/b/c";;
check "sqlite://user:secret@machine:42/a:c/b/c";;
check "sqlite://user:secret@machine:42/a:c/b/c?a=1;b=2";;
check "pgsql://user:secret@machine:42/a:c/b/c?a=1;b=2;";;
check "pgsql://user:secret@machine:42/a:c/b/c?a=1";;
check "pgsql://user:secret@machine:42/a:c/b/c?a=1";;
check "pgsql://user:secret@machine:42/a:c/b/c?";;


